// C Source File

#include <tigcclib.h>         // Include All Header Files
#include "extgraph.h"
#include "preshift.h"

// Temporaire ?
extern unsigned short sc1p160x240_t[256];

// Le rsultat de 160->240->160 est meilleur, mais le rsultat de 240->160->240 est moins bon.
//unsigned char t[4] = {0b000,0b011,0b110,0b111};
// Le rsultat de 160->240->160 est moins bon, mais le rsultat de 240->160->240 est meilleur.
//unsigned char t[4] = {0b000,0b001,0b100,0b111};
void gen_table(void) {
    unsigned short i = 0, res = 0;
    unsigned short *ptr = sc1p160x240_t;
    for (i = 0; i < 256; i++) {
/*
        res = t[(i>>6)&3] << 13;
        res |= t[(i>>4)&3] << 10;
        res |= t[(i>>2)&3] << 7;
        res |= t[(i>>0)&3] << 4;
        *ptr++ = res;
*/
        res = t[(i>>6)&3];
        res <<= 3;
        res |= t[(i>>4)&3];
        res <<= 3;
        res |= t[(i>>2)&3];
        res <<= 3;
        res |= t[(i>>0)&3];
        *ptr++ = res << 4;
    }
}

// Main Function
void _main(void) {
    LCD_BUFFER lcd,lcd2;

    LCD_save(lcd);
    gen_table();

    if (!TI89) {
        FillScreenWithGarbage_R(0x384037EF,LCD_SIZE,lcd2);
        Scale1Plane240to160_R(lcd,lcd2);
        ClrScr();
        LCD_restore(lcd2);
        ngetchx();

        FillScreenWithGarbage_R(0x384037EF,LCD_SIZE,lcd);
        Scale1Plane160to240_R(lcd2,lcd);
        ClrScr();
        LCD_restore(lcd);
        ngetchx();
    }
    else {
        FillScreenWithGarbage_R(0x384037EF,LCD_SIZE,lcd2);
        Scale1Plane160to240_R(lcd,lcd2);
        ClrScr();
        LCD_restore(lcd2);
        ngetchx();

        FillScreenWithGarbage_R(0x384037EF,LCD_SIZE,lcd);
        Scale1Plane240to160_R(lcd2,lcd);
        ClrScr();
        LCD_restore(lcd);
        ngetchx();
    }

    ngetchx();
}
